﻿Type=Class
Version=5.2
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	
	Dim nativeMe As JavaObject
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	
	nativeMe = Me

End Sub

Sub drawDataMatrixCode (data As String) As Bitmap
	
	Return nativeMe.RunMethod("drawDataMatrixCode", Array(data))
	
End Sub


#If Java

import android.graphics.Bitmap;
import android.graphics.Point;
import android.os.Bundle;
import android.util.Log;
import android.view.Display;
import android.view.View;
import android.view.WindowManager;
import android.widget.ImageView;
import android.content.Context;

import java.util.Collection;
import java.util.EnumMap;
import java.util.HashSet;
import java.util.Map;

import com.google.zxing.Writer;
import com.google.zxing.BarcodeFormat;
import com.google.zxing.EncodeHintType;
import com.google.zxing.MultiFormatWriter;
import com.google.zxing.WriterException;
import com.google.zxing.common.BitMatrix;
import com.google.zxing.datamatrix.DataMatrixWriter;


public Bitmap drawDataMatrixCode (String data) {
        Bitmap bitmap = encodeAsBitmap(data, 14, 14);
		return bitmap;
}

public Bitmap encodeAsBitmap(String text, int width, int height){

    BitMatrix matrix = null;
    Writer writer = new DataMatrixWriter();

    try {

        matrix = writer.encode(text, BarcodeFormat.DATA_MATRIX, 14, 14, null);
    } catch (WriterException ex) {
        ex.printStackTrace();
    }
	
	int BLACK = 0xFF000000;
	int WHITE = 0xFFFFFFFF;
	// change the values to your needs
	int requestedWidth = 200;
	int requestedHeight = 200;
	width = matrix.getWidth();
	height = matrix.getHeight();
	// calculating the scaling factor
	int pixelsize = requestedWidth/width;
	if (pixelsize > requestedHeight/height) {
	   pixelsize = requestedHeight/height;
	}
	int[] pixels = new int[requestedWidth * requestedHeight];
	// All are 0, or black, by default
	for (int y = 0; y < height; y++) {
	   int offset = y * requestedWidth * pixelsize;
	   // scaling pixel height
	   for (int pixelsizeHeight = 0; pixelsizeHeight < pixelsize; pixelsizeHeight++, offset+=requestedWidth) {
	       for (int x = 0; x < width; x++) {
	           int color = matrix.get(x, y) ? BLACK : WHITE;
               // scaling pixel width
               for (int pixelsizeWidth = 0; pixelsizeWidth < pixelsize; pixelsizeWidth++) {
	                 pixels[offset + x * pixelsize + pixelsizeWidth] = color;
               }
	       }
	   }
	}
	Bitmap bitmap = Bitmap.createBitmap(requestedWidth, requestedHeight, Bitmap.Config.ARGB_8888);
	bitmap.setPixels(pixels, 0, requestedWidth, 0, 0, requestedWidth, requestedHeight);
	// I could only test it with BufferedImage and a modified version of the zxing J2SE client
	// BufferedImage bitmap = new BufferedImage(requestedWidth, requestedHeight, BufferedImage.TYPE_INT_ARGB);
	// bitmap.getRaster().setDataElements(0, 0, requestedWidth, requestedHeight, pixels);	

	return bitmap;

}

#End If

